VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cVBErrorsSM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'  FILE:        cVBErrors.cls
'               Microsoft TPC-H Kit Ver. 2.7.0-1005
'               Copyright Microsoft, 2008
'               All Rights Reserved
'
'
'  PURPOSE:     This module encapsulates the handling of Visual Basic errors.
'               This module does not do any error handling - any error handler
'               will erase the errors object!
'  Contact:     Reshma Tharamal (reshmat@microsoft.com)
'
Option Explicit

' The Execute class exposes a method, WriteError through which we can write to the
' error log that is currently being used by the Execute object. Store a reference to
' Execute object locally.
Private mcExecObjRef As EXECUTEDLLLib.Execute
Public Sub WriteError(ByVal ErrorCode As errErrorConstants, _
        Optional ByVal ErrorSource As String = gstrEmptyString, _
        Optional ByVal OptArgs As String = gstrEmptyString)

    Dim sError As String
    
    sError = "StepMaster Error:" & ErrorCode & vbCrLf & LoadResString(ErrorCode) & vbCrLf

    If Not StringEmpty(ErrorSource) Then
        sError = sError & "(Source: " & ErrorSource & ")" & vbCrLf
    End If
    sError = sError & OptArgs
    
    Call LogMessage(sError)
    
End Sub
Private Function InitErrorString() As String
    ' Initializes a string with all the properties of the
    ' Err object
            
    Dim strError As String
    Dim errCode As Long
    
    If Err.Number = 0 Then
        InitErrorString = gstrEmptyString
    Else
    With Err
        If Err.Number > vbObjectError And Err.Number < (vbObjectError + 65536) Then
            errCode = .Number - vbObjectError
        Else
            errCode = .Number
        End If
        strError = "Error #: " & errCode & vbCrLf
        strError = strError & "Description: " & .Description & vbCrLf
        strError = strError & "Source: " & Err.Source & vbCrLf
    End With
    
    Debug.Print strError
    InitErrorString = strError
    End If
    
End Function
Public Sub LogVBErrors()
        
    Dim strErr As String
    
    strErr = InitErrorString
    
    On Error GoTo LogVBErrorsErr
    
    If Not StringEmpty(strErr) Then
        ' Write an error using the WriteError method of the Execute object.
        If Not mcExecObjRef Is Nothing Then
            mcExecObjRef.WriteError strErr
        Else
            WriteMessage strErr
        End If
    End If
    
    Err.Clear
    
    Exit Sub

LogVBErrorsErr:
    Call LogErrors(Errors)
    ' Since write to the error file for the step has failed, write to the project log
    Call WriteMessage(strErr)

End Sub
Public Sub DisplayErrors()
        
    Dim strErr As String
    
    strErr = InitErrorString

    If Not StringEmpty(strErr) Then
        ' Display the error message
        MsgBox strErr
    End If
    
    Err.Clear
    
End Sub
Public Sub LogMessage(strMsg As String)
    
    On Error GoTo LogMessageErr
    
    ' Write an error using the WriteError method of the Execute object.
    If Not mcExecObjRef Is Nothing Then
        mcExecObjRef.WriteError strMsg
    Else
        WriteMessage strMsg
    End If
    
    Exit Sub

LogMessageErr:
    Call LogErrors(Errors)
    ' Since write to the error file for the step has failed, write to the project log
    Call WriteMessage(strMsg)

End Sub
Public Property Set ErrorFile(vdata As EXECUTEDLLLib.Execute)
    
    Set mcExecObjRef = vdata

End Property
Private Sub Class_Terminate()

    Set mcExecObjRef = Nothing

End Sub
